#ifndef __COLOR_H__
#define __COLOR_H__

#define COLBIT_RESET      0x01
#define COLBIT_BOLD       0x02
#define COLBIT_FAINT      0x04
#define COLBIT_ITALICED   0x08
#define COLBIT_UNDERLINED 0x10
#define COLBIT_BLINK      0x20
#define COLBIT_           0x40
#define COLBIT_NEGATIVE   0x80

#define BLACK     0
#define RED       1
#define GREEN     2
#define YELLOW    3
#define BLUE      4
#define MAGENTA   5
#define CYAN      6
#define WHITE     7
#define DEFAULT_F 8
#define DEFAULT_B 9
#define XCOL1     10
#define XCOL2     11
#define XCOL3     12
#define XCOL4     13
#define XCOL5     14
#define XCOL6     15 /* max value */

#define DEFCOL_MODE ((DEFAULT_B<<12) | (DEFAULT_F<<8) | COLBIT_RESET)
#define MODE_TO_T(bits) ((bits >> 8 ) & 0x000f)
#define MODE_TO_B(bits) ((bits >> 12) & 0x000f)

struct session *comm_color(const unsigned char *arg, session *ses);
void color_to_text(unsigned char *color, unsigned char *text, unsigned short);
void text_to_color(const unsigned char *text, unsigned char *color,
		   struct session *ses);
void color_to_bits(const unsigned char *color, unsigned short &bits, window *);
int bits_to_color(const unsigned short obits, const unsigned short nbits,
		  unsigned char *color);
#endif
