#ifndef __ENVIRONMENT_H__
#define __ENVIRONMENT_H__ 1

class env_elem {
public:
  env_elem(const uchar *, const uchar *);
  ~env_elem();
  
friend class env_list;
  
  int is_well_known() const { return(well_known); }
  
private:
  
  uchar *name;
  uchar *value;
  
  int well_known;
  
  env_elem *next, *prev;
};

class env_list {
public:
  env_list();
  ~env_list();
  
  void add(const uchar *, const uchar *);
  void remove(const uchar *);
  void set_well_known(const uchar *);
  
  env_elem *find(const uchar *) const;
  const uchar *find_value(const uchar *) const;
  
  void start_sb_is(int, int &);
  void add_sb_is(const env_elem *);
  void add_all_sb_is(const int);
  int end_sb_is(int, session *);

  const uchar *parse_name(const uchar *, const uchar *, uchar *) const;
  
private:

  uchar *res_line;
  int len, size, var_nr, value_nr;

  env_elem *envs;
};

#ifndef __ENVIRONMENT_C__
extern env_list environment_list;
#endif

#endif
