/*********************************************************************/
/* File: main.c - main module - signal setup/shutdown etc            */
/*                             TINTIN III                            */
/*          (T)he K(I)cki(N) (T)ickin D(I)kumud Clie(N)t             */
/*                     coded by peter unold 1992                     */
/*********************************************************************/
/*
 *
 * HISTORY
 *
 * $Log: main.cc,v $
// Revision 1.33  1996/03/28  13:44:13  oat
// pl20.
//
// Revision 1.32  1995/09/09  16:07:56  oat
// ht v1.2 pl19 beta
//
// Revision 1.31  1995/09/05  04:14:53  oat
// 050995 version 1.2 pl19 beta
//
// Revision 1.30  1995/09/05  01:03:05  oat
// 05.09.1995 before new color modes.
//
// Revision 1.29  1995/06/19  12:54:34  oat
// version pl18 before new X-Window scroll.
//
// Revision 1.28  1995/03/13  14:37:57  oat
// ht 1.2 pl16 beta
//
// Revision 1.27  1995/02/06  22:20:36  oat
// ht1.2pl6beta
//
// Revision 1.26  1995/01/13  07:33:18  oat
// HUT TINTIN v1.2 beta (X-Window version)
//
// Revision 1.25  1995/01/07  04:34:24  oat
// v1.2 alpha pl2
//
// Revision 1.24  1995/01/05  20:27:30  oat
// ht v1.2aalpha pl1
//
// Revision 1.23  1995/01/05  05:40:46  oat
// first XWindow version (alpha)
//
// Revision 1.22  1994/12/20  18:26:10  oat
// ht1.1pl2
//
// Revision 1.21  1994/11/26  06:20:40  oat
// v1.1
//
// Revision 1.20  1994/11/10  19:16:21  oat
// added quietmode.
//
// Revision 1.19  1994/11/08  23:21:00  oat
// ht v1.0 pl1
//
// Revision 1.18  1994/11/08  17:06:03  oat
// ht v1.0
//
// Revision 1.17  1994/10/07  15:03:23  oat
// Changed start text.
//
// Revision 1.16  1994/10/04  14:01:22  oat
// ht v 1.0 beta
//
// Revision 1.15  1994/09/28  05:20:39  oat
// ht V0.9_27
//
// Revision 1.14  1994/09/17  23:59:28  oat
// v 0.9_26
//
// Revision 1.13  1994/09/17  12:56:11  oat
// v 0.9_25
//
// Revision 1.12  1994/09/14  23:16:17  oat
// *** empty log message ***
//
// Revision 1.11  1994/09/08  18:09:23  oat
// *** empty log message ***
//
// Revision 1.10  1994/08/31  17:55:02  oat
// "\n" changed to be "\n\r"
//
// Revision 1.9  1994/08/30  19:49:12  oat
// changed version number.
//
// Revision 1.8  1994/08/30  13:55:40  oat
// *** empty log message ***
//
// Revision 1.7  1994/08/17  02:33:55  oat
// *** empty log message ***
//
// Revision 1.6  1994/08/12  08:53:18  oat
// old version before new screen history system ;)
//
// Revision 1.5  1994/07/31  00:02:42  oat
// now multi wondow screen should work.
// (so lets see how many bug fixes version come ;)
//
// Revision 1.4  1994/07/28  01:30:38  oat
// chars marked signed or unsigned
//
// Revision 1.3  1994/07/27  16:51:37  oat
// bug fixes.
//
// Revision 1.2  1994/07/27  14:04:15  oat
// Bugs fixes.
//
// Revision 1.1  1994/07/26  17:18:56  oat
// Initial revision
//
 *
 */

#define __HT_MAIN_C__ 1

#include "structs.h"

#include <ctype.h>
#include <string.h>
#include <sys/time.h>
#include <assert.h>

#include "types.h"

#ifndef sigmask
#  define sigmask(sig) (1 << ((sig) - 1))
#endif

#include "files.h"
#include "history.h"
#include "llist.h"
#include "main.h"
#include "misc.h"
#include "net.h"
#include "parse.h"
#include "screen.h"
#include "session.h"
#include "ticks.h"
#include "utility.h"
#include "utils.h"

#ifndef X_DISPLAY_MISSING
#  include <X11/StringDefs.h> 
#  include <X11/IntrinsicP.h>
#  include <X11/Shell.h>
#  include <X11/keysym.h>
#  include <X11/Xatom.h>

#if defined(HAVE_X11_XAW_DIALOG_H) && defined(HAVE_LIBXAW)
#  include <X11/Xaw/Dialog.h>
#endif

XtAppContext MainContext;
Display *MainDisplay = 0;

#include "xscreen.h"
#endif

#ifndef BADSIG
#  define BADSIG (void (*)(...))-1
#endif

#define CTRLSPACE (const uchar *)"\000"
#define CTRLA     (const uchar *)"\001"
#define CTRLB     (const uchar *)"\002"
#define CTRLC     (const uchar *)"\003"
#define CTRLD     (const uchar *)"\004"
#define CTRLE     (const uchar *)"\005"
#define CTRLF     (const uchar *)"\006"
#define CTRLG     (const uchar *)"\007"
#define CTRLH     (const uchar *)"\010"   /* backspace */
#define CTRLI     (const uchar *)"\011"   /* tab       */
/* #define CTRLJ 10  return */
#define CTRLK     (const uchar *)"\013"
#define CTRLL     (const uchar *)"\014"
/* #define CTRLM 10  return */
#define CTRLN     (const uchar *)"\016"
#define CTRLO     (const uchar *)"\017"
#define CTRLP     (const uchar *)"\020"
#define CTRLQ     (const uchar *)"\021"
#define CTRLR     (const uchar *)"\022"
#define CTRLS     (const uchar *)"\023"
#define CTRLT     (const uchar *)"\024"
#define CTRLU     (const uchar *)"\025"
#define CTRLV     (const uchar *)"\026"
#define CTRLW     (const uchar *)"\027"
#define CTRLX     (const uchar *)"\030"
#define CTRLY     (const uchar *)"\031"
#define CTRLZ     (const uchar *)"\032"
#define DEL       (const uchar *)"\177"
#define ACSI -101
#define INPUTBUF master_table.inputbuf
#define INPUTPOS master_table.inputbuf_pos
#define CURSOR   master_table.cursor_pos
#define TIMESPERSEC 10

/*************** globals ******************/
int idletime = 0;
int sessionsstarted;
int default_chars_per_line = DEFAULT_CHARS_PER_LINE;
int default_lines_in_scr = DEFAULT_LINES_IN_SCR;
int signalmask    = sigmask(SIGALRM) | sigmask(SIGWINCH) | sigmask(SIGPROF);
int ownsignalmask = sigmask(SIGALRM) | sigmask(SIGPROF);
int quietmode = FALSE;
struct master_table_data master_table;
unsigned char vars[10][BUFFER_SIZE]; /* the $0, $1, $2,....$9 variables */
unsigned char tintin_char = DEFAULT_TINTIN_CHAR;
unsigned char tintin_retchar = DEFAULT_RETURN_CHAR;
unsigned char text_start = DEFAULT_TEX_START_CHAR;
unsigned char text_end = DEFAULT_TEX_END_CHAR;
unsigned char verbatim_char = DEFAULT_VERBATIM_CHAR;
void (*last_func)(int, window *) = 0;

const char *mail_path = 0;
time_t mail_mtime = 0;

extern unsigned char *selection;
extern int selection_len;

const uchar *version_num = (const uchar *)"1.2 beta pl20";

int key_data::amount = 0;

key_data::key_data()
{
  int i;
  
  for(i = 0; i < 256; i++)
    keys[i] = 0;
  
  func = 0;
  
  key_data::amount++;
}

key_data::~key_data()
{
  int i;
  
  for(i = 0; i < 256; i++) {
    if(keys[i]) {
      delete keys[i];
    }
  }
  
  key_data::amount--;
}

struct key_func_table keys[256];

/************ externs *************/
extern int ticker_interrupted;
extern int window_interrupted;
extern const unsigned char *comm_names[];

extern const uchar *CLEARSCREEN;
extern const uchar *AUTOWARPON;
extern const uchar *RESETCOLOR;

extern unsigned short default_color;
extern const char *color_names[];
extern int color_nums[];

// *******************
//  master table init
// *******************

master_table_data::master_table_data()
{
  int i;
  
  for(i = 0; i < HISTORY_SIZE; i++)
    history[i] = 0;
  history_pos   = 0;
  *inputbuf     = '\0';
  inputbuf_pos  = 0;
  inputbuf2_pos = 0;
  cursor_pos    = 0;
  utexrem       = FALSE;
  ucommand      = FALSE;
  aliascalls    = 0;
  output_window = 0;
  main_session  = 0;
  
  master_flags  = DEFAULT_MASTER_FLAGS;
}

/* ************************************************
   functions for keyboard reading and initilization
   ************************************************ */

void insert_char(unsigned char letter, int prompt_len, window *activ)
{
  unsigned char *tmpstr, tmp[2];
  int i, pos, lines;
  const position *cursor;
  session *ses;

  ses = activ->get_active_ses();
  
  if(ses &&
     !ses->is_set_flag(SES_FLAG_LINEMODE) &&
     ses->get_socket() >= 0 &&
     !activ->get_hist_on()) {
    if(INPUTPOS > 0) {
      if(write_socket(INPUTBUF,ses->get_socket(),INPUTPOS) < 0) {
	ses->print_errmsg("write socket");
	ses->rem_net();
	return;
      }
      *INPUTBUF = '\0';
      INPUTPOS = 0;
      CURSOR   = 0;
    }
    tmp[0] = letter;
    tmp[1] = '\0';
    if(write_socket(tmp, ses->get_socket(), 1) < 0) {
      ses->print_errmsg("write socket");
      ses->rem_net();
      return;
    }
    return;
  }
  
  if(letter >= ' ' && INPUTPOS < (int)sizeof(INPUTBUF) - 1) {
    tmpstr = INPUTBUF + CURSOR;
    for(i = INPUTPOS; i > CURSOR; i--)
      *(INPUTBUF + i) = *(INPUTBUF + i - 1);
    
    *(INPUTBUF + CURSOR) = letter;
    INPUTPOS++;
    CURSOR++;
    *(INPUTBUF + INPUTPOS) = '\0';
    
    if(activ->get_hist_on()) {
      if(activ->hist_search(INPUTBUF, 0))
	activ->print_win_hist_line(FALSE);
    } else {
      if(activ->get_active_ses()->is_set_flag(SES_FLAG_TERMECHO)) {
	activ->print(tmpstr);
	
	if(INPUTPOS > CURSOR) {
	  lines = ((INPUTPOS + prompt_len) / activ->get_cols()) -
	    ((CURSOR + prompt_len) / activ->get_cols());
	  pos = (CURSOR + prompt_len) % activ->get_cols();
	  cursor = activ->get_cursor();
	  activ->move(cursor->row - lines, pos + 1, TRUE);
	}
      }
    }
  } else if(letter != '\n' && ses->is_set_flag(SES_FLAG_KEYBELL)) {
    activ->bell();
  }
}

void func_home(int prompt_len, window *activ)
{
  int lines;
  const position *cursor;
  
  if(activ->get_hist_on()) {
    activ->hist_home();
  } else {
    if(CURSOR) {
      lines = (prompt_len + CURSOR) / activ->get_cols();
      cursor = activ->get_cursor();
      activ->move(cursor->row - lines, prompt_len + 1, TRUE);
      CURSOR = 0;
    }
  }
}

void func_end(int prompt_len, window *activ)
{
  int pos, lines;
  const position *cursor;
  
  if(activ->get_hist_on()) {
    activ->hist_end();
  } else {
    if(CURSOR != INPUTPOS) {
      lines = ((INPUTPOS + prompt_len) / activ->get_cols()) -
	((CURSOR + prompt_len) / activ->get_cols());
      pos = (INPUTPOS + prompt_len) % activ->get_cols();
      cursor = activ->get_cursor();
      activ->move(cursor->row + lines, pos + 1, TRUE);
      CURSOR = INPUTPOS;

    } else if(activ->get_active_ses()->is_set_flag(SES_FLAG_KEYBELL)) {
      activ->bell();
    }
  }
}

void func_pageup(int prompt_len, window *activ)
{
  window *win;

  if(activ->get_hist_on()) {
    activ->hist_pageup();
  } else {
    func_screen_hist(prompt_len, activ);
    win = activ->get_active_ses()->get_output();
    win->move(win->get_size()->start, 1, FALSE);
    win->hist_pageup();
  }
}

void func_pagedown(int, window *activ)
{
  if(activ->get_hist_on()) {
    activ->hist_pagedown();

  } else if(activ->get_active_ses()->is_set_flag(SES_FLAG_KEYBELL)) {
    activ->bell();
  }
}

void func_arrowup(int, window *activ)
{
  if(activ->get_hist_on()) {
    activ->hist_backward();
  } else {
    if(master_table.history_pos < HISTORY_SIZE &&
       master_table.history[master_table.history_pos]) {
      activ->remove_user_text();
      
      INPUTPOS = str_cat(INPUTBUF, 0, sizeof(INPUTBUF),
			 master_table.history[master_table.history_pos]);
      CURSOR = INPUTPOS;
      activ->print_prompt(FALSE);
      master_table.history_pos++;
    }
  }
}

void func_arrowdown(int, window *activ)
{
  if(activ->get_hist_on()) {
    activ->hist_forward();
  } else {
    if(master_table.history_pos > 1) {
      activ->remove_user_text();
      INPUTPOS = str_cat(INPUTBUF, 0, sizeof(INPUTBUF),
			 master_table.history[master_table.history_pos - 2]);
      CURSOR = INPUTPOS;
      activ->print_prompt(FALSE);
      master_table.history_pos--;
    } else if(master_table.history_pos == 1) {
      activ->remove_user_text();
      *INPUTBUF = '\0';
      INPUTPOS = 0;
      CURSOR = 0;
      activ->print_prompt(FALSE);
      master_table.history_pos--;
    }
  }
}

void func_arrowright(int, window *activ)
{
  if(activ->get_hist_on()) {
    activ->hist_moveforward();
  } else {
    if(CURSOR < INPUTPOS) {
      CURSOR++;
      activ->moveforward();
      
    } else if(activ->get_active_ses()->is_set_flag(SES_FLAG_KEYBELL)) {
      activ->bell();
    }
  }
}

void func_arrowleft(int, window *activ)
{
  if(activ->get_hist_on()) {
    activ->hist_movebackward();
  } else {
    if(CURSOR > 0) {
      CURSOR--;
      activ->movebackward();

    } else if(activ->get_active_ses()->is_set_flag(SES_FLAG_KEYBELL)) {
      activ->bell();
    }
  }
}

void func_delete_char(int, window *activ)
{
  unsigned char *tmpstr;
  int i;
  position cursor;
  
  if(CURSOR != INPUTPOS) {
    INPUTPOS--;
    for(i = CURSOR, tmpstr = INPUTBUF + CURSOR; i <= INPUTPOS; i++) {
      *(INPUTBUF + i) = *(INPUTBUF + i + 1);
    }
    *(INPUTBUF + INPUTPOS) = '\0';
    if(activ->get_hist_on()) {
      activ->print_win_hist_line(FALSE);
    } else {
      cursor = *activ->get_cursor();
      activ->print(tmpstr);
      activ->print((const uchar *)" ");
      activ->move(&cursor, TRUE);
    }

  } else if(activ->get_active_ses()->is_set_flag(SES_FLAG_KEYBELL)) {
    activ->bell();
  }
}

void func_delete_word(int, window *activ)
{
  unsigned char *tmpstr, buf[BUFFER_SIZE];
  int i, len;
  position cursor;
  
  if(activ->get_hist_on()) {
    // search current or previos word begin
    while(CURSOR > 0 &&
	  (!*(INPUTBUF + CURSOR) || isspace(*(INPUTBUF + CURSOR))))
      CURSOR--;
    
    while(CURSOR > 0 && *(INPUTBUF + CURSOR - 1) > ' ')
      CURSOR--;
  } else {
    cursor = *activ->get_cursor();
    
    // search current or previos word begin
    while(CURSOR > 0 &&
	  (!*(INPUTBUF + CURSOR) || isspace(*(INPUTBUF + CURSOR)))) {
      CURSOR--;
      
      if(!(--cursor.col)) {
	cursor.col = activ->get_cols();
	if(cursor.row > activ->get_scroll()->start)
	  cursor.row--;
      }
    }
    
    while(CURSOR > 0 && *(INPUTBUF + CURSOR - 1) > ' ') {
      CURSOR--;
      
      if(!(--cursor.col)) {
	cursor.col = activ->get_cols();
	if(cursor.row > activ->get_scroll()->start)
	  cursor.row--;
      }
    }
    
    activ->move(&cursor, TRUE);
  }
  for(len = 0;
      CURSOR + len != INPUTPOS && *(INPUTBUF + CURSOR + len) > ' ';
      len++)
    ;
  
  // all spaces after word removed too
  while(CURSOR + len < INPUTPOS && isspace(*(INPUTBUF + CURSOR + len)))
    len++;
  
  if(len > 0) {
    INPUTPOS -= len;
    
    for(i = CURSOR, tmpstr = INPUTBUF + CURSOR; i <= INPUTPOS; i++) {
      *(INPUTBUF + i) = *(INPUTBUF + i + len);
    }
    *(INPUTBUF + INPUTPOS) = '\0';
    
    if(activ->get_hist_on()) {
      activ->print_win_hist_line(FALSE);
    } else {
      for(i = 0; i < len; i++)
	buf[i] = ' ';
      buf[i] = '\0';
      
      activ->print(tmpstr);
      activ->print(buf);
      activ->move(&cursor, TRUE);
    }
    
  } else if(activ->get_active_ses()->is_set_flag(SES_FLAG_KEYBELL)) {
    activ->bell();
  }
}

void func_cut_line(int, window *activ)
{
  if(activ->get_hist_on()) {
    if(INPUTPOS) {
      *INPUTBUF = '\0';
      INPUTPOS = 0;
      CURSOR   = 0;
      activ->print_win_hist_line(FALSE);
    }
  } else {
    INPUTPOS = CURSOR;
    *(INPUTBUF + INPUTPOS) = '\0';
    activ->clearend();
  }
}

void func_delete_line(int prompt_len, window *activ)
{
  int lines;
  const position *cursor;
  
  if(activ->get_hist_on()) {
    if(INPUTPOS) {
      *INPUTBUF = '\0';
      INPUTPOS = 0;
      CURSOR   = 0;
      activ->print_win_hist_line(FALSE);
    }
  } else {
    if(CURSOR) {
      lines = (prompt_len + CURSOR) / activ->get_cols();
      cursor = activ->get_cursor();
      activ->move(cursor->row - lines, prompt_len + 1, TRUE);
      CURSOR = 0;
    }
    INPUTPOS = 0;
    *INPUTBUF = '\0';
    activ->clearend();
  }
}

void func_redraw_screen(int, window *)
{
  redraw_screen();
}

void func_return(int prompt_len, window *activ)
{
  int pos, lines;
  session *ses;

  static uchar inputbuf2[BUFFER_SIZE] = "";
  static int inside = 0;
  
  if(activ->get_hist_on()) {
    activ->hist_search(INPUTBUF);
  } else {
    ses = activ->get_active_ses();
    
    lines = ((INPUTPOS + prompt_len) / activ->get_cols()) -
      ((CURSOR + prompt_len) / activ->get_cols());
    if(lines > 0) {
      pos = (INPUTPOS + prompt_len) % activ->get_cols();
      activ->move(activ->get_cursor()->row + lines, pos + 1, FALSE);
    }
    
    if(ses->is_set_flag(SES_FLAG_TERMECHO)) {
      do_history(INPUTBUF, activ);
    }
    
    if(add_str(inputbuf2, master_table.inputbuf2_pos, sizeof(inputbuf2),
	       inside, INPUTBUF, FALSE, ses) &&
       *INPUTBUF) {
      INPUTPOS = 0;
      CURSOR   = 0;
      *INPUTBUF = '\0';
    } else {
      INPUTPOS = 0;
      CURSOR   = 0;
      *INPUTBUF = '\0';
      
      master_table.inputbuf2_pos = 0;
      
      master_table.ucommand = TRUE;
      parse_input(inputbuf2, ses);
      master_table.ucommand = FALSE;
      *inputbuf2 = '\0';
      inside = 0;
    }
    
    CheckNewMail();
  }
#ifndef X_DISPLAY_MISSING
  DrawFunc();
#endif
}

void func_backspace(int, window *activ)
{
  unsigned char *tmpstr;
  int i;
  struct position cursor;

  if(CURSOR) {
    INPUTPOS--;
    CURSOR--;
    for(i = CURSOR, tmpstr = INPUTBUF + CURSOR; i <= INPUTPOS; i++) {
      *(INPUTBUF + i) = *(INPUTBUF + i + 1);
    }
    *(INPUTBUF + INPUTPOS) = '\0';
    
    if(activ->get_hist_on()) {
      activ->print_win_hist_line(FALSE);
    } else {
      activ->movebackward();
      cursor = *activ->get_cursor();
      
      activ->print(tmpstr);
      activ->print((const uchar *)" ");
      activ->move(&cursor, TRUE);
    }

  } else if(activ->get_active_ses()->is_set_flag(SES_FLAG_KEYBELL)) {
    activ->bell();
  }
}

void func_wordfill(int prompt_len, window *activ)
{
  unsigned char *tmpstr, tmp[BUFFER_SIZE];
  const unsigned char *f_word, *s_word;
  int f_word_pos, s_word_pos, i, j, pos, found;
  session *ses;

  ses = activ->get_active_ses();
  
  if(CURSOR) {
    for(i = CURSOR; i > 0 && ownisalnum(*(INPUTBUF + i - 1)); i--)
      ;
    if(i > 0 && *(INPUTBUF + i - 1) == tintin_char)
      i--;

    for(tmpstr = tmp; i < CURSOR; i++)
      *tmpstr++ = *(INPUTBUF + i);
    *tmpstr = '\0';
  } else {
    *tmp = '\0';
  }
  
  f_word_pos = s_word_pos = -1;
  for(i = 0; i < ses->word_list_pos; i++)
    if(is_abrev(ses->word_list[i], tmp)) {
      f_word_pos = i;
      break;
    }
  if(f_word_pos >= 0) {
    for(; i < ses->word_list_pos; i++)
      if(!is_abrev(ses->word_list[i], tmp)) {
	s_word_pos = i - 1;
	break;
      }
    if(s_word_pos < 0)
      s_word_pos = i - 1;
    
    f_word = ses->word_list[f_word_pos];
    s_word = ses->word_list[s_word_pos];
    
    for(pos = strlen((const char *)tmp), j = 1;
	*(f_word + pos) && 
	*(f_word + pos) == *(s_word + pos);
	pos++, j++)
      insert_char(*(f_word + pos), prompt_len, activ);
    
    if(!*(f_word + pos) && !*(s_word + pos)) {
      if(ses->is_set_flag(SES_FLAG_WFESPACE)) {
	insert_char(' ', prompt_len, activ);
      }
    } else {
      if(!activ->get_hist_on()) {
	pos = str_cat(tmp, 0, sizeof(tmp), (const uchar *)"\n\r#Words:");
	for(i = f_word_pos; i <= s_word_pos; i++) {
	  if((i - f_word_pos) % 5 == 4)
	    pos = str_cat(tmp, pos, sizeof(tmp), (const uchar *)"\n\r#      ");
	  pos = str_cat(tmp, pos, sizeof(tmp), (const uchar *)" '");
	  pos = str_cat(tmp, pos, sizeof(tmp), ses->word_list[i]);
	  pos = str_cat(tmp, pos, sizeof(tmp), (const uchar *)"'");
	}
	pos = str_cat(tmp, pos, sizeof(tmp), (const uchar *)"\n\r");
	ses->print(tmp);
	ses->get_output()->set_ptexrem();
      }
    }
  } else {
    if((f_word = ses->search_hist_word(tmp, pos))) {
      for(i = strlen((const char *)tmp);
	  ownisalnum(*(f_word + i)) && i < pos;
	  i++)
	insert_char(*(f_word + i), prompt_len, activ);
      
      if(i < pos && ses->is_set_flag(SES_FLAG_WFESPACE)) {
	insert_char((unsigned char)' ', prompt_len, activ);
      }
      
    } else {
      found = FALSE;
      if(*tmp == tintin_char && *(tmp + 1)) {
	for(i = 0; *comm_names[i] != '\n'; i++) {
	  if(is_abrev(comm_names[i], tmp + 1)) {
	    for(pos = strlen((const char *)tmp + 1);
		*(comm_names[i] + pos);
		pos++)
	      insert_char(*(comm_names[i] + pos), prompt_len, activ);
	    
	    if(ses->is_set_flag(SES_FLAG_WFESPACE)) {
	      insert_char((unsigned char)' ', prompt_len, activ);
	    }
	    found = TRUE;
	    break;
	  }
	}
      }
      
      if(!found && (f_word = ses->search_hist_word(tmp, pos, TRUE))) {
	for(i = strlen((const char *)tmp);
	    ownisalnum(*(f_word + i)) && i < pos;
	    i++)
	  insert_char(*(f_word + i), prompt_len, activ);

	if(i < pos && ses->is_set_flag(SES_FLAG_WFESPACE)) {
	  insert_char((unsigned char)' ', prompt_len, activ);
	}
	found = TRUE;
      }
      
      if(!found && CURSOR > 0 && CURSOR == INPUTPOS) {
	for(i = 0; i < HISTORY_SIZE && master_table.history[i]; i++) {
	  if(is_abrev(master_table.history[i], INPUTBUF))
	    break;
	}
	if(i == HISTORY_SIZE || !master_table.history[i]) {
	  for(i = 0; i < HISTORY_SIZE && master_table.history[i]; i++)
	    if(is_abrev(master_table.history[i], INPUTBUF, TRUE))
	      break;
	}
	if(i < HISTORY_SIZE && master_table.history[i]) {
	  pos = i;
	  
	  for(i = INPUTPOS; *(master_table.history[pos] + i); i++)
	    insert_char(*(master_table.history[pos] + i), prompt_len, activ);
	  
	  found = TRUE;
	}
      }
      
      if(!found && !activ->get_hist_on()) {
	sprintf((char *)tmp,
		"\n\r#No such word start in word list or this session"
		" history\n\r# (%d lines checked)\n\r",
		ses->get_output()->get_size()->end - 
		ses->get_output()->get_size()->start + 1);
	ses->print(tmp);
	ses->get_output()->set_ptexrem();
      }
    }
  }
}

void func_comlinefill(int prompt_len, window *activ)
{
  uchar buf[BUFFER_SIZE];
  int pos = 0, lines, i;
  session *ses;
  const position *cursor;
  
  static int old_pos = -1, len = 0, ignore_case = FALSE;
  
  ses = activ->get_active_ses();
  
  if(activ->get_hist_on()) {
    if(ses->is_set_flag(SES_FLAG_KEYBELL)) {
      activ->bell();
    }
  } else if(CURSOR > 0 && CURSOR == INPUTPOS) {
    if(last_func != func_comlinefill) {
      old_pos = -1;
      len = 0;
      len = str_cat(buf, 0, sizeof(buf), INPUTBUF);
      ignore_case = FALSE;
    } else {
      memcpy(buf, INPUTBUF, len);
      *(buf + len) = '\0';
    }
    
    if(!ignore_case) {
      for(pos = old_pos + 1;
	  pos < HISTORY_SIZE && master_table.history[pos];
	  pos++) {
	if(is_abrev(master_table.history[pos], buf))
	  break;
      }
      if(pos == HISTORY_SIZE || !master_table.history[pos]) {
	ignore_case = TRUE;
	old_pos = -1;
	pos = 0;
      }
    }
    if(ignore_case) {
      pos = old_pos;
      if(old_pos == -1 ||
	 (old_pos < HISTORY_SIZE && master_table.history[old_pos])) {
	for(pos = old_pos + 1;
	    pos < HISTORY_SIZE && master_table.history[pos];
	    pos++)
	  if(is_abrev(master_table.history[pos], buf, TRUE))
	    break;
      }
    }
    old_pos = pos;
    if(old_pos < HISTORY_SIZE && master_table.history[old_pos]) {
      if(len != CURSOR) {
	lines = ((len + prompt_len) / activ->get_cols()) -
	  ((CURSOR + prompt_len) / activ->get_cols());
	pos = (len + prompt_len) % activ->get_cols();
	cursor = activ->get_cursor();
	activ->move(cursor->row + lines, pos + 1, FALSE);
      }
      INPUTPOS = len;
      CURSOR   = len;
      *(INPUTBUF + len) = '\0';
      activ->clearend();
      
      for(i = len; *(master_table.history[old_pos] + i); i++)
	insert_char(*(master_table.history[old_pos] + i), prompt_len, activ);
    }
  }
}

void func_system_comm(int prompt_len, window *activ)
{
  int pos, lines;
  unsigned char tmp[BUFFER_SIZE];
  
  if(activ->get_hist_on()) {
    if(activ->get_active_ses()->is_set_flag(SES_FLAG_KEYBELL)) {
      activ->bell();
    }
    
  } else {
    str_cat(tmp, 0, sizeof(tmp), INPUTBUF);
    
    lines = ((INPUTPOS + prompt_len) / activ->get_cols()) -
      ((CURSOR + prompt_len) / activ->get_cols());
    if(lines > 0) {
      pos = (INPUTPOS + prompt_len) % activ->get_cols();
      activ->move(activ->get_cursor()->row + lines, pos + 1, FALSE);
    }
    
    *INPUTBUF = '\0';
    INPUTPOS = 0;
    CURSOR   = 0;

    if(activ->get_active_ses()->is_set_flag(SES_FLAG_TERMECHO)) {
      do_history(tmp, activ);
    }
    system_command(tmp, activ->get_active_ses());
  }
}

void func_screen_hist(int, window *activ)
{
  session *ses;

  ses = activ->get_active_ses();
  
  if(activ->get_hist_on()) {
    if(ses->is_set_flag(SES_FLAG_KEYBELL)) {
      activ->bell();
    }
    
  } else {
    ses->get_output()->start_win_history(ses);
  }
}

#ifndef X_DISPLAY_MISSING

void ok_exit_CallBackProc(Widget w, Widget parent, XtPointer)
{
  XtDestroyWidget(w);
  XtDestroyWidget(parent);
  
  exit_tintin(0);
}

void cancel_exit_CallBackProc(Widget w, Widget parent, XtPointer)
{
  XtDestroyWidget(w);
  XtDestroyWidget(parent);
}
#endif

void func_quit(int, window *activ)
{
#if !defined(X_DISPLAY_MISSING) && defined(HAVE_X11_XAW_DIALOG_H) && defined(HAVE_LIBXAW)
  Arg  wargs[10];
  int  n;
  Widget parent, dialog;
  
  const char *title = "Confirmation";
  
  if(MainDisplay &&
     activ->get_active_ses()->is_set_flag(SES_FLAG_ASK_CONFIRM)) {

    n = 0;
    /*
       XtSetArg(wargs[n], XtNwidth,  220);
       n++;
       XtSetArg(wargs[n], XtNheight, 50);
       n++;
       */
    XtSetArg(wargs[n], XtNx,
	     (DisplayWidth(MainDisplay, DefaultScreen(MainDisplay)) -
	      220) / 2);
    n++;
    XtSetArg(wargs[n], XtNy,
	     (DisplayHeight(MainDisplay, DefaultScreen(MainDisplay)) -
	      50) / 2);
    n++;
    
    parent = XtAppCreateShell(title, title, applicationShellWidgetClass,
			      MainDisplay, wargs, n);
    
    n = 0;
    XtSetArg(wargs[n], XtNlabel, "Are you sure you wanna quit ?");
    n++;
    XtSetArg(wargs[n], XtNvalue, 0);
    n++;
    
    dialog = XtCreateManagedWidget("dialog", dialogWidgetClass,
				   parent, wargs, n);
    
    XawDialogAddButton(dialog, "Yes",    ok_exit_CallBackProc, parent);
    XawDialogAddButton(dialog, "Cancel", cancel_exit_CallBackProc, parent);
    
    XtRealizeWidget(parent);
    
  } else
#endif
    exit_tintin(0);
}

void func_clear(int, window *activ)
{
  if(activ->get_hist_on()) {
    if(activ->get_active_ses()->is_set_flag(SES_FLAG_KEYBELL)) {
      activ->bell();
    }
    
  } else {
    activ->clear();
    activ->print_prompt(TRUE, FALSE);
  }
}

void func_nextwindow(int, window *activ)
{
  activ->next_window_active();
}

void func_nextsession(int, window *activ)
{
  uchar buf[BUFFER_SIZE];
  session *ses, *next_ses;
  
  ses = activ->get_active_ses();
  
  if(!(next_ses = ses->get_next()))
    next_ses = master_table.main_session;
  
  if(next_ses == ses) {
    if(ses->is_set_flag(SES_FLAG_KEYBELL)) {
      activ->bell();
    }
    return;
  }
  
  activ->remove_user_text();
  
  sprintf((char *)buf, "#SESSION '%s' ACTIVATED.\n\r", next_ses->get_name());
  ses->print(buf);
  activ->set_ptexrem();
  
  if(!next_ses->is_set_flag(SES_FLAG_LINEMODE) &&
     next_ses->get_socket() >= 0) {
    *INPUTBUF = '\0';
    INPUTPOS  = 0;
    CURSOR    = 0;
    master_table.utexrem = FALSE;
  }
  
  next_ses->get_input()->set_active_ses(next_ses);
  if(ses->get_input() != next_ses->get_input()) {
    window::get_active_win()->next_window_active(next_ses->get_input());

    activ->print_prompt(TRUE, FALSE);
  }
  window::get_active_win()->print_prompt(TRUE, FALSE);
}

void func_exit_win_hist(int, window *activ)
{
  if(activ->get_hist_on())
    activ->exit_win_history();

  else if(activ->get_active_ses()->is_set_flag(SES_FLAG_KEYBELL)) {
    activ->bell();
  }
}

void func_mark(int, window *activ)
{
  if(activ->get_hist_on()) {
    activ->hist_set_mark();
  }
}

void func_copy_clip(int, window *activ)
{
  if(activ->get_hist_on()) {
    activ->hist_copy_clip();
  }
}

#ifndef X_DISPLAY_MISSING

void selectionCallbackProc(Widget, XtPointer client_data,
			   Atom * /* selection */ ,
			   Atom *type,
			   XtPointer value, unsigned long *length,
			   int * /* format */)
{
  uchar *tmp = (uchar *)value;
  window *activ = (window *)client_data;
  int prompt_len;
  ulong len;

  if(*type == XA_STRING && *length > 0 && value) {
    
    prompt_len = activ->get_active_ses()->get_prompt_len();
    
    for(len = 0; len < *length; len++)
      insert_char(*(tmp + len), prompt_len, activ);
  }
  
  if(value)
    XtFree((char *)tmp);
}
#endif

void func_insert_clip(int prompt_len, window *activ)
{
  int i;
  session *ses;
  
  ses = activ->get_active_ses();

  if(selection) {
    for(i = 0; i < selection_len; i++)
      insert_char(*(selection + i), prompt_len, activ);
  }
#ifndef X_DISPLAY_MISSING
  else if(MainDisplay) {
    
    if(!XGetSelectionOwner(MainDisplay, XA_PRIMARY)) {
      
      unsigned char *tmp;
      int nbytes;
      
      tmp = (uchar *)XFetchBytes(MainDisplay, &nbytes);
      for(i = 0; i < nbytes; i++)
	insert_char(*(tmp + i), prompt_len, activ);
      
      if(tmp) {
	XtFree((char *)tmp);
      }
      
    } else {

      XtGetSelectionValue(activ->get_base()->widget, XA_PRIMARY, XA_STRING,
			  selectionCallbackProc, activ, CurrentTime);
    }
  }
#endif
}

void add_key_string(const uchar *str, void (*f)(int, window *))
{
  int i, found = FALSE;
  key_data *tmp;
  
  if(!str || !f) {
    return;
  }
  
  if(!*(str + 1)) {
    if(keys[*str].func != f) {
      
      if(keys[*str].key) {
	found = TRUE;
	delete keys[*str].key;
	keys[*str].key = 0;
      }
      
#ifdef DEBUG
      if(keys[*str].func || found)
	filelog("#INFO: replacing old key with new one");
#endif
      
      keys[*str].func = f;
    }
  } else {
    if(keys[*str].func) {
      keys[*str].func = 0;
      found = TRUE;
    }
    
    if(!keys[*str].key) {
      keys[*str].key = new key_data;
    }
    tmp = keys[*str].key;
    str++;
    
    while(*str) {
      if(!tmp->keys[*str]) {
	tmp->keys[*str] = new key_data;
      }
      tmp = tmp->keys[*str];
      str++;
    }
    
    for(i = 0; i < 256; i++) {
      if(tmp->keys[i]) {
	delete tmp->keys[i];
	tmp->keys[i] = 0;
	found = TRUE;
      }
    }
#ifdef DEBUG
    if((tmp->func && tmp->func != f) || found)
      filelog("#INFO: replacing old string with new one");
#endif
    
    tmp->func = f;
  }
}

void init_key_table(void)
{
  int i;
#ifndef X_DISPLAY_MISSING
  KeySym shiftkey_list[2];
  int shiftkey_num = 0;
#ifdef XK_Shift_L
  shiftkey_list[shiftkey_num++] = XK_Shift_L;
#endif
#ifdef XK_Shift_R
  shiftkey_list[shiftkey_num++] = XK_Shift_R;
#endif
  KeySym ctrlkey_list[2];
  int ctrlkey_num = 0;
#ifdef XK_Control_L
  ctrlkey_list[ctrlkey_num++] = XK_Control_L;
#endif
#ifdef XK_Control_R
  ctrlkey_list[ctrlkey_num++] = XK_Control_R;
#endif
#endif
  
  for(i = 0; i < 256; i++) {
    keys[i].key  = 0;
    keys[i].func = 0;
    keys[i].always = FALSE;
  }
  
  add_key_string(CTRLSPACE, func_mark);
  add_key_string(CTRLA,     func_home);
  add_key_string(CTRLB,     func_arrowleft);
  add_key_string(CTRLC,     func_quit);
  add_key_string(CTRLD,     func_delete_char);
  add_key_string(CTRLE,     func_end);
  add_key_string(CTRLF,     func_arrowright);
  add_key_string(CTRLG,     func_copy_clip);
  add_key_string(CTRLH,     func_backspace);
  add_key_string(CTRLI,     func_wordfill);
  add_key_string(CTRLK,     func_cut_line);
  add_key_string(CTRLL,     func_redraw_screen);
  add_key_string(CTRLN,     func_arrowdown);
  add_key_string(CTRLO,     func_nextwindow);
  keys[*CTRLO].always = TRUE;
  add_key_string(CTRLP,     func_arrowup);
  add_key_string(CTRLU,     func_delete_line);
  add_key_string(CTRLV,     func_screen_hist);
  keys[*CTRLV].always = TRUE;
  add_key_string(CTRLW,     func_delete_word);
  add_key_string(CTRLX,     func_exit_win_hist);
  add_key_string(CTRLY,     func_insert_clip);
  add_key_string(CTRLZ,     func_system_comm);
  add_key_string((const uchar *)"\r", func_return);
  add_key_string((const uchar *)"\n", func_return);
  add_key_string(DEL,       func_backspace);

  add_key_string((const uchar *)"\033[1~", func_home);
  add_key_string((const uchar *)"\033[2~", func_insert_clip);
  add_key_string((const uchar *)"\033[4~", func_end);
  add_key_string((const uchar *)"\033[5~", func_pageup);
  add_key_string((const uchar *)"\033[6~", func_pagedown);
  add_key_string((const uchar *)"\033[A",  func_arrowup);
  add_key_string((const uchar *)"\033[B",  func_arrowdown);
  add_key_string((const uchar *)"\033[C",  func_arrowright);
  add_key_string((const uchar *)"\033[D",  func_arrowleft);
  add_key_string((const uchar *)"\033[[A", func_mark);
  add_key_string((const uchar *)"\033[[B", func_copy_clip);
  add_key_string((const uchar *)"\033[[C", func_comlinefill);
  
#ifndef X_DISPLAY_MISSING
  if(MainDisplay) {
#ifdef XK_Home
    XRebindKeysym(MainDisplay, XK_Home,      0, 0,
		  (const uchar *)"\033[1~", 4);
#endif
#ifdef XK_Insert
    XRebindKeysym(MainDisplay, XK_Insert,    0, 0,
		  (const uchar *)"\033[2~", 4);
    if(shiftkey_num > 0)
      XRebindKeysym(MainDisplay, XK_Insert,    shiftkey_list, shiftkey_num,
		    (const uchar *)"\033[2~", 4);
    if(ctrlkey_num > 0)
      XRebindKeysym(MainDisplay, XK_Insert,    ctrlkey_list, ctrlkey_num,
		    (const uchar *)"\033[[B", 4);
#endif
#ifdef XK_End
    XRebindKeysym(MainDisplay, XK_End,       0, 0,
		  (const uchar *)"\033[4~", 4);
#endif
#ifdef XK_Page_Up
    XRebindKeysym(MainDisplay, XK_Page_Up,   0, 0,
		  (const uchar *)"\033[5~", 4);
#endif
#ifdef XK_Page_Down
    XRebindKeysym(MainDisplay, XK_Page_Down, 0, 0,
		  (const uchar *)"\033[6~", 4);
#endif
#ifdef XK_Up
    XRebindKeysym(MainDisplay, XK_Up,        0, 0, (const uchar *)"\033[A", 3);
    if(shiftkey_num > 0)
      XRebindKeysym(MainDisplay, XK_Up,   shiftkey_list, shiftkey_num,
		    (const uchar *)"\033[5~", 4);
#endif
#ifdef XK_Down
    XRebindKeysym(MainDisplay, XK_Down,      0, 0, (const uchar *)"\033[B", 3);
    if(shiftkey_num > 0)
      XRebindKeysym(MainDisplay, XK_Down, shiftkey_list, shiftkey_num,
		    (const uchar *)"\033[6~", 4);
#endif
#ifdef XK_Right
    XRebindKeysym(MainDisplay, XK_Right,     0, 0, (const uchar *)"\033[C", 3);
#endif
#ifdef XK_Left
    XRebindKeysym(MainDisplay, XK_Left,      0, 0, (const uchar *)"\033[D", 3);
#endif
#ifdef XK_F1
    XRebindKeysym(MainDisplay, XK_F1,        0, 0,
		  (const uchar *)"\033[[A", 4);
#endif
#ifdef XK_F2
    XRebindKeysym(MainDisplay, XK_F2,        0, 0,
		  (const uchar *)"\033[[B", 4);
		  #endif
#ifdef XK_Tab
    if(shiftkey_num > 0) {
      XRebindKeysym(MainDisplay, XK_Tab, shiftkey_list, shiftkey_num,
                    (const uchar *)"\033[[C", 4);
    }
#endif
  }
#endif
}

void init_signals()
{
#ifdef HAVE_SIGACTION
  struct sigaction siga;
  
  bzero((char *)&siga, sizeof(siga));
  siga.sa_flags   = SA_RESTART;
  
  siga.sa_handler = myquitsig;
  if(sigaction(SIGTERM, &siga, 0))
    syserr("signal SIGTERM");
  
  siga.sa_handler = myquitsig;
  if(sigaction(SIGINT, &siga, 0))
    syserr("signal SIGINT");
  
#ifndef X_DISPLAY_MISSING
  if(MainDisplay)
    siga.sa_handler = SIG_IGN;
  else
#endif
    siga.sa_handler = window_func;
  if(sigaction(SIGWINCH, &siga, 0))
    syserr("signal SIGWINCH");
  
  siga.sa_handler = SIG_IGN;
  if(sigaction(SIGALRM, &siga, 0))
    syserr("signal SIGALRM");
  if(sigaction(SIGQUIT, &siga, 0))
    syserr("signal SIGQUIT");
  
#ifndef X_DISPLAY_MISSING
  if(!MainDisplay)
#endif
    if(sigaction(SIGTSTP, &siga, 0))
      syserr("signal SIGTSTP");
  
  if(sigaction(SIGPIPE, &siga, 0))   // Ignore broken pipe signal
    syserr("signal SIGPIPE");
#else
  
  if(signal(SIGTERM, myquitsig) == BADSIG)
    syserr("signal SIGTERM");
  
  if(signal(SIGINT, myquitsig) == BADSIG)
    syserr("signal SIGINT");
  
  if(signal(SIGALRM, SIG_IGN) == BADSIG)
    syserr("signal SIGALRM");
  
  if(signal(SIGWINCH, window_func) == BADSIG)
    syserr("signal SIGWINCH");
  
  if(signal(SIGQUIT, SIG_IGN) == BADSIG)
    syserr("signal SIGQUIT");
  
#ifndef X_DISPLAY_MISSING
  if(!MainDisplay)
#endif
    if(signal(SIGTSTP, SIG_IGN) == BADSIG)
      syserr("signal SIGTSTP");
  
  if(signal(SIGPIPE, SIG_IGN) == BADSIG)        // Ignore broken pipe signal
    syserr("signal SIGPIPE");
#endif
}

// ***************************************
//  function to ignoring SIG_WINCH on/off
// ***************************************

void sigmask_on()
{
#ifndef X_DISPLAY_MISSING
  assert(!MainDisplay);
#endif

#ifdef HAVE_SIGACTION
  struct sigaction siga;
  
  bzero((char *)&siga, sizeof(siga));
  siga.sa_flags   = SA_RESTART;
  siga.sa_handler = SIG_IGN;
  
  if(sigaction(SIGWINCH, &siga, 0))
    syserr("signal SIGWINCH");
#else
  if(signal(SIGWINCH, SIG_IGN) == BADSIG)
    syserr("signal SIGWINCH");
#endif
  
  sigsetmask(signalmask);
}

void sigmask_off()
{
#ifndef X_DISPLAY_MISSING
  assert(!MainDisplay);
#endif

#ifdef HAVE_SIGACTION
  struct sigaction siga;
  
  bzero((char *)&siga, sizeof(siga));
  siga.sa_flags   = SA_RESTART;
  
  siga.sa_handler = window_func;
  if(sigaction(SIGWINCH, &siga, 0))
    syserr("signal SIGWINCH");
#else
  if(signal(SIGWINCH, window_func) == BADSIG)
    syserr("signal SIGWINCH");
#endif
  
  sigsetmask(0);
}

const struct key_elem key_functions[] = {
  {(const uchar *)"arrowdown",      func_arrowdown,
   (const uchar *)"Next command in command history/cursor down."},
  {(const uchar *)"arrowleft",      func_arrowleft,
   (const uchar *)"Cursor move one left."},
  {(const uchar *)"arrowright",     func_arrowright,
   (const uchar *)"Cursor move one right."},
  {(const uchar *)"arrowup",        func_arrowup,
   (const uchar *)"Previous command in command history/cursor up."},
  {(const uchar *)"backspace",      func_backspace,
   (const uchar *)"Delete previous char."},
  {(const uchar *)"clear",          func_clear,
   (const uchar *)"Clear window."},
  {(const uchar *)"copy",           func_copy_clip,
   (const uchar *)"Copy marked text to clip buffer."},
  {(const uchar *)"cut_line",       func_cut_line,
   (const uchar *)"Delete rest of line from cursor position."},
  {(const uchar *)"delete_char",    func_delete_char,
   (const uchar *)"Delete character under cursor."},
  {(const uchar *)"delete_line",    func_delete_line,
   (const uchar *)"Delete whole line."},
  {(const uchar *)"delete_word",    func_delete_word,
   (const uchar *)"Delete current or previous word."},
  {(const uchar *)"endkey",         func_end,
   (const uchar *)"End of line/End of session history."},
  {(const uchar *)"exit_history",   func_exit_win_hist,
   (const uchar *)"Exit from session history."},
  {(const uchar *)"expand_cmdline", func_comlinefill,
   (const uchar *)"Expand line from command history."},
  {(const uchar *)"expand_word",    func_wordfill,
   (const uchar *)"Expand word from word list, screen, etc..."},
  {(const uchar *)"homekey",        func_home,
   (const uchar *)"Beginning of line/session history."},
  {(const uchar *)"mark",           func_mark,
   (const uchar *)"Mark start position for text clipping."},
  {(const uchar *)"next_session",   func_nextsession,
   (const uchar *)"Activate next session."},
  {(const uchar *)"next_window",    func_nextwindow,
   (const uchar *)"Activate next window."},
  {(const uchar *)"open_history",   func_screen_hist,
   (const uchar *)"Open session history from active session."},
  {(const uchar *)"pagedown",       func_pagedown,
   (const uchar *)"Page down in session history."},
  {(const uchar *)"pageup",         func_pageup,
   (const uchar *)"Page up in session history."},
  {(const uchar *)"paste",          func_insert_clip,
   (const uchar *)"Paste text from clip buffer."},
  {(const uchar *)"quit",           func_quit,
   (const uchar *)"Quit ht."},
  {(const uchar *)"redraw",         func_redraw_screen,
   (const uchar *)"Redraw screen (text mode)/window (X-Window)"},
  {(const uchar *)"shell",          func_system_comm,
   (const uchar *)"Execute shell command or open shell."},
  {(const uchar *)"\n", 0, 0}
};

unsigned char ctrl_nums['z' - 'a' + 1] = {
  1,  2,  3,  4,  5,  6,  7,  8,  9,  0,
  11, 12,  0, 14, 15, 16, 17, 18, 19, 20,
  21, 22, 23, 24, 25, 26
  };

session *comm_ctrl(const unsigned char *arg, session *ses)
{
  unsigned char letter[BUFFER_SIZE], name[BUFFER_SIZE], *tmp;
  int pos, i, j, ctrl_num = -1, always = FALSE;
  
  arg = get_arg_stop_spaces(arg, letter);
  tmp = letter;
  if(*tmp == '-') {
    tmp++;
    while(isspace(*tmp))
      tmp++;
    
    while(*tmp) {
      switch(*tmp) {
      case 'a':
	always = TRUE;
	break;
      default:
	sprintf((char *)name, "#Unknown flag '%c'.\n\r", *tmp);
	ses->print(name);
	break;
      }
      tmp++;
      while(isspace(*tmp))
	tmp++;
    }
    arg = get_arg_stop_spaces(arg, letter);
  }

  arg = get_arg_with_spaces(arg, name);
  
  if(*letter && !*(letter + 1)) {
    if(*letter < 'a' ||
       *letter > 'z' ||
       (ctrl_num = ctrl_nums[*letter - 'a']) < 1) {
      ses->print((const uchar *)"#Sorry you can't use that ctrl key\n\r");
      return(ses);
    }
    if(*name) {
      for(i = 0; *key_functions[i].name != '\n'; i++) {
	if(is_abrev(key_functions[i].name, name)) {
	  keys[ctrl_num].func = key_functions[i].func;
	  keys[ctrl_num].always = always;
	  if(keys[ctrl_num].key) {
	    delete keys[ctrl_num].key;
	    keys[ctrl_num].key = 0;
	  }
	  ses->print((const uchar *)"#Ok.\n\r");
	  return(ses);
	}
      }
    } else {
      if(keys[ctrl_num].func) {
	for(i = 0; *key_functions[i].name != '\n'; i++) {
	  if(key_functions[i].func == keys[ctrl_num].func) {
	    pos = str_cat(name, 0, BUFFER_SIZE,
			  (const uchar *)"#That ctrl key is: ");
	    pos = str_cat(name, pos, BUFFER_SIZE, key_functions[i].name);
	    if(keys[ctrl_num].always)
	      pos = str_cat(name, pos, BUFFER_SIZE,
			    (const uchar *)" (always)");
	    pos = str_cat(name, pos, BUFFER_SIZE,
			  (const uchar *)"\n\r");
	    ses->print(name);
	    return(ses);
	  }
	}
	ses->print((const uchar *)"#That ctrl key is: UNKNOWN FUNCTION ? :/\n\r");
      } else {
	ses->print((const uchar *)"#That ctrl key is: NOTHING.\n\r");
      }
      return(ses);
    }
  }
  pos = str_cat(name, 0, BUFFER_SIZE,
		(const uchar *)"#Next functions are available:\n\r");
  for(i = 0; *key_functions[i].name != '\n'; i++) {
    for(j = 0; j < 'z' - 'a' + 1; j++)
      if(keys[j + 1].func == key_functions[i].func)
	break;
    
    if(j < 'z' - 'a' + 1) {
      sprintf((char *)letter, "   (ctrl-%c) %-15s %s\n\r",
	      j + 'a',
	      key_functions[i].name,
	      key_functions[i].descr);
    } else {
      sprintf((char *)letter, "            %-15s %s\n\r",
	      key_functions[i].name,
	      key_functions[i].descr);
    }
    
    pos = str_cat(name, pos, BUFFER_SIZE, letter);
  }
  ses->print(name);
  return(ses);
}

// ***************
//  usage message
// ***************

void print_usage(const char *name)
{
  printf("Usage: %s ARGUMENTS\n\r", name);
  printf("Possible arguments:\n\r");
  printf(" [--] FILENAME                  command file to read in start.\n\r");
  printf(" -bg COLORNAME                  background color.\n\r");
  printf(" -fg COLORNAME                  foreground color.\n\r");
  printf(" -fn FONTNAME                   font to use.\n\r");
  printf(" -font FONTNAME                 font to use.\n\r");
  printf(" -geometry GEOMETRY             size (in characters) and position.\n\r");
  printf(" -help                          print out this message.\n\r");
  printf(" -nw                            don't open own window in X-Window.\n\r");
  printf(" -quiet                         don't print anything on screen in start.\n\r");
  printf(" -xcol1 COLORNAME               xcol1 color.\n\r");
  printf(" -xcol2 COLORNAME               xcol2 color.\n\r");
  printf(" -xcol3 COLORNAME               xcol3 color.\n\r");
  printf(" -xcol4 COLORNAME               xcol4 color.\n\r");
  printf(" -xcol5 COLORNAME               xcol5 color.\n\r");
  printf(" -xcol6 COLORNAME               xcol6 color.\n\r");
  exit(0);
}

/**************************************************************************/
/* main() - show title - setup signals - init lists - readcoms - tintin() */
/**************************************************************************/
int main(int argc, char *argv[])
{
  char *font_name = 0, *def_geometry = 0;
  unsigned char buf[1000], *filename = 0, *tmp_arg;
  int i, pos, no_xwindow = FALSE;
  basewindow *base;

#define ARGNUM 15

  const uchar *arg_names[ARGNUM] = {
    (const uchar *)"-",
    (const uchar *)"bg",
    (const uchar *)"fn",
    (const uchar *)"fg",
    (const uchar *)"font",
    (const uchar *)"geometry",
    (const uchar *)"help",
    (const uchar *)"nw",
    (const uchar *)"quiet",
    (const uchar *)"xcol1",
    (const uchar *)"xcol2",
    (const uchar *)"xcol3",
    (const uchar *)"xcol4",
    (const uchar *)"xcol5",
    (const uchar *)"xcol6"
    };
  
  for(i = 0; i < 10; i++) {
    *vars[i] = '\0';
  }
  
  mail_path = getenv("MAIL");
  
  pos = 1;
  while(pos < argc) {
    tmp_arg = (uchar *)argv[pos++];
    if(*tmp_arg == '-') {
      tmp_arg++;
      
      for(i = 0; i < ARGNUM; i++)
	if(is_abrev(arg_names[i], tmp_arg))
	  break;
      
      if(*tmp_arg && i < ARGNUM) {
	switch(i) {
	case 0: // '-'
	  if(pos < argc)
	    filename = (uchar *)argv[pos++];
	  break;
	case 1: // 'bg'
	  if(pos < argc) {
	    color_names[DEFAULT_B] = argv[pos];
	    pos++;
	  }
	  break;
	case 3: // 'fg'
	  if(pos < argc) {
	    color_names[DEFAULT_F] = argv[pos];
	    pos++;
	  }
	  break;
	case 2: // 'fn'
	case 4: // 'font'
	  if(pos < argc)
	    font_name = argv[pos++];
	  break;
	case 5: // 'geometry'
	  if(pos < argc)
	    def_geometry = argv[pos++];
	  break;
	case 6: // 'help'
	  print_usage(argv[0]);
	  break;
	case 7: // 'nw'
	  no_xwindow = TRUE;
	  break;
	case 8: // 'quiet'
	  quietmode = TRUE;
	  break;
	case 9: /* xcol1 */
	  if(pos < argc) {
	    color_names[XCOL1] = argv[pos];
	    pos++;
	  }
	  break;
	case 10: /* xcol2 */
	  if(pos < argc) {
	    color_names[XCOL2] = argv[pos];
	    pos++;
	  }
	  break;
	case 11: /* xcol3 */
	  if(pos < argc) {
	    color_names[XCOL3] = argv[pos];
	    pos++;
	  }
	  break;
	case 12: /* xcol4 */
	  if(pos < argc) {
	    color_names[XCOL4] = argv[pos];
	    pos++;
	  }
	  break;
	case 13: /* xcol5 */
	  if(pos < argc) {
	    color_names[XCOL5] = argv[pos];
	    pos++;
	  }
	  break;
	case 14: /* xcol6 */
	  if(pos < argc) {
	    color_names[XCOL6] = argv[pos];
	    pos++;
	  }
	  break;
	}
      } else {
	printf("Unknown argument '-%s'\n\r", tmp_arg);
	print_usage(argv[0]);
      }
    } else {
      filename = tmp_arg;
    }
  }
  
#ifndef HAVE_SRANDOM
  srand(time(0));
#else
  srandom(time(0));
#endif
  init_screen(no_xwindow);
  init_key_table();
  init_comms_table();
  
#ifndef X_DISPLAY_MISSING
  if(MainDisplay) {
    init_termcap();
    
    base = new basewindow((const uchar *)"main", def_geometry, font_name, 0);
  } else {
#endif
    /* default text to ansi white and default background to ansi black
       and all x-window special colors ro ansi white                    */
    color_nums[DEFAULT_F] = WHITE + 30;
    color_nums[DEFAULT_B] = BLACK + 30;
    color_nums[XCOL1]     = WHITE + 30;
    color_nums[XCOL2]     = WHITE + 30;
    color_nums[XCOL3]     = WHITE + 30;
    color_nums[XCOL4]     = WHITE + 30;
    color_nums[XCOL5]     = WHITE + 30;
    color_nums[XCOL6]     = WHITE + 30;

    init_termcap();
    base = new basewindow((const uchar *)"main", 0, 0, 0);
#ifndef X_DISPLAY_MISSING
  }
#endif
  
  master_table.main_session = new session;
  
  sprintf((char *)buf, "Screen size: %dx%d\n\r", base->cols, base->rows);
  
  if(!quietmode) {
    master_table.main_session->print(buf);
    
    master_table.main_session->print((const uchar *)"###################################################\n\r"
				     "#                    H U T                        #\n\r"
				     "#                 T I N T I N                     #\n\r"
				     "#                                                 #\n\r"
				     "#  (T)he k(I)cki(N) (T)ickin d(I)kumud clie(N)t   #\n\r"
				     "#  Orginal TINTIN III coded by peter unold 1992   #\n\r"
				     "#                  HUT TINTIN                     #\n\r"
				     "# coded by Ossi Tulonen 1992-1995 from TINTIN III #\n\r"
				     "###################################################\n\r");
  }

  init_signals();
  
  read_command(filename, master_table.main_session);
  
  if(quietmode) {
    quietmode = FALSE;
  } else {
    comm_version((unsigned char *)"", master_table.main_session);
  }
  
  window::get_active_win()->set_ptexrem();
  prompt();

  tintin();
  exit_tintin(0);
  exit(0);
}

/***************************/
/* the main loop of tintin */
/***************************/
#ifndef X_DISPLAY_MISSING
void XTickFunc(XtPointer, XtIntervalId *)
{
  TickFunc();
  XtAppAddTimeOut(MainContext, 1000, XTickFunc, NULL);
}

void XDrawFunc(XtPointer, XtIntervalId *)
{
  DrawFunc();
  XtAppAddTimeOut(MainContext, 500, XDrawFunc, NULL);
}

inline void XReadUser(XtPointer, int *, XtInputId *)
{
  ReadUser();
}
#endif

void tintin(void)
{
#ifndef X_DISPLAY_MISSING
  XtAppAddTimeOut(MainContext, 1000, XTickFunc, NULL);
  /* 1000milliseconds = 1 second */

  XtAppAddTimeOut(MainContext,  500, XDrawFunc, NULL); // check every 1/2 second

  if(!MainDisplay)
    XtAppAddInput(MainContext, fileno(stdin), (XtPointer)XtInputReadMask,
		  XReadUser, NULL);
  
  XtAppMainLoop(MainContext);
#else

  int s, maxnet, sel_res;
#ifndef HAVE_USLEEP
  struct timeval timeout = {0, 1000000/TIMESPERSEC };
#else         // #ifndef HAVE_USLEEP
  long timeout = 1000000/TIMESPERSEC;
#endif        // #ifndef HAVE_USLEEP
  struct timeval null_time = {0, 0};
  fd_set input_set, exc_set;
  session *ses, *sesnext;
  static time_t oldtime = 0;
  
  s = fileno(stdin);
  while(TRUE) {
    FD_ZERO(&input_set);
    FD_ZERO(&exc_set);
    
    FD_SET(s, &input_set);
    FD_SET(s, &exc_set);
    maxnet = s;
    for(ses = master_table.main_session;
	ses;
	ses = ses->get_next()) {
      if(ses->get_socket() >= 0) {
	FD_SET(ses->get_socket(), &input_set);
	FD_SET(ses->get_socket(), &exc_set);
	if(ses->get_socket() > maxnet)
	  maxnet = ses->get_socket();
      }
    }
    sigsetmask(signalmask);
    if((sel_res = select(maxnet + 1, &input_set, (fd_set *)0,
			 &exc_set , &null_time)) < 0)
      syserr("main.cc select");
    sigsetmask(0);
    
    if(sel_res) {
      for(ses = master_table.main_session; ses; ses = sesnext) {
	sesnext = ses->get_next();
	if(ses->get_socket() >= 0) {
	  /*
	     if(FD_ISSET(ses->get_socket(), &exc_set)) {
	     printf("EXC %s", ses->name);
	     }
	     */
	  
	  if(FD_ISSET(ses->get_socket(), &input_set)) {
	    ReadNet(ses);
	  }
	}
      }
      
      if(FD_ISSET(s, &input_set)) {
	ReadUser();
      }
    }
#ifndef HAVE_USLEEP
    select(1, (fd_set *)0, (fd_set *)0, (fd_set *)0, &timeout);
#else
    usleep(timeout);
#endif
    if(oldtime != time(0)) {
      oldtime = time(0);
      
      TickFunc();
    }
  }
#endif   // #ifndef X_DISPLAY_MISSING
}

/*************************************************************/
/* read text from user and test for alias                    */
/*************************************************************/

void ReadUser(
#ifndef X_DISPLAY_MISSING
	      XKeyEvent *event
#endif
	      )
{
  unsigned char buffer[100], letter, *rbuf, tmp[2] = {'\0', '\0'};
  int didget, i = 0, prompt_len, pos;
  window *activ;
  session *ses;
  key_data *key_tmp;
  
  static unsigned char oldbuf[20] = "";
  
  if(window::get_active_win()->get_hist_clip())
    window::get_active_win()->hist_rem_clip_color();
  
  rbuf = buffer;
  if(*oldbuf) {
    rbuf += str_cat(rbuf, 0, sizeof(buffer), oldbuf);
    *oldbuf = '\0';
  }
  
#ifndef X_DISPLAY_MISSING
  if(event) {
    if((didget = XLookupString(event, (char *)rbuf,
			       sizeof(buffer) - 1 - (rbuf - buffer),
			       0, 0)) <= 0) {
      if(buffer != rbuf) {
	str_cat(oldbuf, 0, sizeof(oldbuf), buffer);
      }
      return;
    }
  } else
#endif
    if((didget = read(0, rbuf, sizeof(buffer) - 1 - (rbuf - buffer))) < 0) {
      window::get_active_win()->get_active_ses()->print_errmsg("read from stdin");
      return;
    }

  didget += rbuf - buffer;
  
  idletime = 0;    // User wrote something :)

  while(INPUTPOS < (int)sizeof(INPUTBUF) - 1 && i < didget) {

    // printf("\nnum: %d: ", (int)*(buffer + i));
    
    activ = window::get_active_win();
    ses   = activ->get_active_ses();
    prompt_len = ses->get_prompt_len();

    letter = *(buffer + i++);
    if(ses->is_set_flag(SES_FLAG_LINEMODE) ||
       ses->get_socket() < 0 ||
       activ->get_hist_on() ||
       INPUTPOS > 0) {
      
      if(keys[letter].func) {
	(keys[letter].func)(prompt_len, activ);
	last_func = keys[letter].func;
	
      } else if(keys[letter].key) {
	key_tmp = keys[letter].key;
	pos = 0;
	oldbuf[pos++] = letter;

	while(i < didget && key_tmp->keys[*(buffer + i)]) {
	  oldbuf[pos++] = *(buffer + i);
	  key_tmp = key_tmp->keys[*(buffer + i++)];
	}
	if(key_tmp->func) {
	  oldbuf[0] = '\0';
	  (key_tmp->func)(prompt_len, activ);
	  last_func = key_tmp->func;
	  
	} else if(i < didget) {
	  oldbuf[0] = '\0';
	  last_func = 0;
	  
	} else {
	  oldbuf[pos] = '\0';
	}
      } else {
	last_func = 0;
	insert_char(letter, prompt_len, activ);
      }
    } else {
      if(keys[letter].func &&
	 keys[letter].always) {
	(keys[letter].func)(prompt_len, activ);
	last_func = keys[letter].func;
      } else {
	last_func = 0;
	tmp[0] = letter;
	if(write_socket(tmp, ses->get_socket(), 1) < 0) {
	  ses->print_errmsg("write socket");
	  ses->rem_net();
	  return;
	}
      }
    }
  }
  if(i < didget) {
    window::get_active_win()->get_active_ses()->print((const uchar *)"#ERROR - You cannot give that long strings.\n\r");
    INPUTPOS = 0;
    CURSOR   = 0;
    *INPUTBUF = '\0';
  }
  prompt();
}

/* ********************************************************
 *      release all memory, reset screen and exit         *
 ******************************************************** */

void exit_tintin(int status)
{
  int i, oldamount;
  const session *ses, *sesnext;
  window *win, *nextwin;
  basewindow *base, *nextbase;
  
  for(ses = session::get_sessions(); ses; ses = sesnext) {
    sesnext = ses->get_next();
    delete (session *)ses;
  }
  
  if(basewindow::get_bases()) {
    for(base = basewindow::get_bases(); base; base = nextbase) {
      nextbase = base->get_next();
      for(win = base->get_windows(); win; win = nextwin) {
	nextwin = win->get_next();
	delete win;
      }
    }
    assert(FALSE);  /* should never come here */
  }

  for(i = 0; i < HISTORY_SIZE; i++)
    if(master_table.history[i])
      free(master_table.history[i]); 
  
  oldamount = key_data::amount;

  for(i = 0; i < 256; i++) {
    if(keys[i].key) {
      delete keys[i].key;
      keys[i].key = 0;
    }
  }

#ifndef X_DISPLAY_MISSING
  if(MainDisplay) {
    FreeColors();
    XtCloseDisplay(MainDisplay);
  } else {
#endif
    window::max_scroll_region();
    printf("%s%s", RESETCOLOR, CLEARSCREEN);
    printf("%s", AUTOWARPON);
    nocbreak_echo();
#ifdef DEBUG
    printf("Keytable size was: %d (=%d bytes)\n\r",
	   oldamount, oldamount*sizeof(key_data));
#endif
    printf("Thanks for using this TinTin.\n\r");
    printf("We hope you like it ;)\n\r");
    printf("Have a nice day (or night).\n\r");
#ifndef X_DISPLAY_MISSING
  }
  XtDestroyApplicationContext(MainContext);
#endif

  exit(status);
}

/**********************************************************/
/* Here's where we go when we wanna quit TINTIN FAAAAAAST */
/**********************************************************/
void myquitsig(...)
{
  exit_tintin(0);
  exit(0);
}
